Package: mashr
Type: Package
Encoding: UTF-8
Title: Multivariate Adaptive Shrinkage
Version: 0.2.79
Date: 2023-10-18
Authors@R: c(person("Matthew","Stephens",role="aut"),
             person("Sarah","Urbut",role="aut"),
             person("Gao","Wang",role="aut"),
             person("Yuxin","Zou",role="aut"),
             person("Yunqi","Yang",role="ctb"),
	     person("Sam","Roweis",role="cph"),
	     person("David","Hogg",role="cph"),
	     person("Jo","Bovy",role="cph"),
             person("Peter","Carbonetto",role=c("aut","cre"),
                    email="peter.carbonetto@gmail.com"))
Description: Implements the multivariate adaptive shrinkage (mash)
    method of Urbut et al (2019) <DOI:10.1038/s41588-018-0268-8> for
    estimating and testing large numbers of effects in many conditions
    (or many outcomes). Mash takes an empirical Bayes approach to
    testing and effect estimation; it estimates patterns of similarity
    among conditions, then exploits these patterns to improve accuracy
    of the effect estimates. The core linear algebra is implemented in
    C++ for fast model fitting and posterior computation.
URL: https://github.com/stephenslab/mashr
BugReports: https://github.com/stephenslab/mashr/issues
License: BSD_3_clause + file LICENSE
Copyright: file COPYRIGHTS
Depends: R (>= 3.3.0), ashr (>= 2.2-22)
Imports: assertthat, utils, stats, plyr, rmeta, Rcpp (>= 1.0.8),
        mvtnorm, abind, softImpute
LinkingTo: Rcpp, RcppArmadillo, RcppGSL (>= 0.3.8)
Suggests: MASS, REBayes, corrplot (>= 0.90), testthat, kableExtra,
        knitr, rmarkdown, profmem, flashier, ebnm
VignetteBuilder: knitr
NeedsCompilation: yes
Biarch: true
Remotes: stephens999/ashr, stephenslab/ebnm, willwerscheid/flashier
RoxygenNote: 7.2.3
Author: Matthew Stephens [aut],
  Sarah Urbut [aut],
  Gao Wang [aut],
  Yuxin Zou [aut],
  Yunqi Yang [ctb],
  Sam Roweis [cph],
  David Hogg [cph],
  Jo Bovy [cph],
  Peter Carbonetto [aut, cre]
Maintainer: Peter Carbonetto <peter.carbonetto@gmail.com>
Built: R 4.4.0; x86_64-apple-darwin18.7.0; 2024-06-02 08:06:26 UTC; unix

# Short script to compare the runtimes of calc_lik_matrix against the
# likelihood calculations within the "mash" function.
library(mashr)

set.seed(1)

grid_min = function(Bhat,Shat){
  min(Shat)/10
}

grid_max = function(Bhat,Shat){
  if (all(Bhat^2 <= Shat^2)) {
    8 * grid_min(Bhat,Shat)
  }  else {
    2 * sqrt(max(Bhat^2 - Shat^2))
  }
}

autoselect_grid = function(data,mult){
  gmax = grid_max(data$Bhat, data$Shat)
  gmin = grid_min(data$Bhat, data$Shat)
  if (mult == 0) {
    return(c(0, gmax/2))
  }
  else {
    npoint = ceiling(log2(gmax/gmin)/log2(mult))
    return(mult^((-npoint):0) * gmax)
  }
}

Bhat   <- matrix(rnorm(10000,0,2),nrow = 100,ncol = 100)
Shat   <- matrix(1,nrow = 100,ncol = 100)
data   <- mash_set_data(Bhat,Shat)
U      <- cov_canonical(data)
grid   <- autoselect_grid(data,sqrt(2))
xUlist <- expand_cov(U,grid,TRUE)

cat("R version:\n")
print(system.time(out1 <- calc_lik_matrix(data,xUlist,
                                          algorithm.version = "R")))
cat("Rcpp version:\n")
print(system.time(out2 <- calc_lik_matrix(data,xUlist,
                                          algorithm.version = "Rcpp")))

cat("Full mash analysis:\n")
out <- mash(data,U,algorithm.version = "Rcpp")

context("test_precomputed.R")
muffled_chol = function(x, ...)
withCallingHandlers(chol(x, ...),
                    warning = function(w) {
                      if (grepl("the matrix is either rank-deficient or indefinite", w$message))
                        invokeRestart("muffleWarning")
                    } )
test_that("Precomputed precision matrix agrees with regular computations for logliklihood", {
  skip("Cannot test it due to numerical differences between chol in armadillo and R ...")
  set.seed(1)
  simdata = simple_sims(500,5,1)
  data = mash_set_data(simdata$Bhat, simdata$Shat, alpha = 0)
  U.c = cov_canonical(data)
  grid = autoselect_grid(data,sqrt(2))
  Ulist = normalize_Ulist(U.c)
  xUlist = expand_cov(Ulist,grid,TRUE)
  loglik1 = calc_lik_rcpp(t(data$Bhat),t(data$Shat),data$V,
                             matrix(0,0,0), simplify2array(xUlist),F,T)$data
  svs = data$Shat[1,] * t(data$V * data$Shat[1,])
  sigma_rooti = list()
  for (i in 1:length(xUlist)) sigma_rooti[[i]] = backsolve(muffled_chol(svs + xUlist[[i]], pivot=T), diag(nrow(svs)))
  loglik2 = calc_lik_common_rcpp(t(data$Bhat),
                                 simplify2array(sigma_rooti),
                                 F)$data
  expect_equal(loglik1, loglik2, tolerance = 1e-4)
})

library(mashr)

# install.packages(repo=NULL,pkgs="mashr_0.1-18.tar.gz",type="source")
#
# For testing, load all packages listed in the "imports" field, and
# load all the functions defined in the source files.
# to overwrite the mashr package defaults.
#
# source("../R/mash.R")
# source("../R/compute_covs.R")
# source("../R/data2cov.R")
# source("../R/ed.R")
# source("../R/get_functions.R")
source("../R/likelihoods.R")
# source("../R/opt.R")
# source("../R/plots.R")
# source("../R/posterior.R")
# source("../R/set_data.R")
# source("../R/simulations.R")

# SCRIPT PARAMETERS.
J <- 1e4
K <- 10 
J <- ceiling(J/4)*4
s <- sqrt(rchisq(J*K,df = J-1)/(J-1))

# Generate a simulated data set.
mash_data   <- simple_sims(J/4,K,s)
mash_data$V <- diag(K)
Ulist       <- cov_canonical(mash_data)
Ulist       <- expand_cov(Ulist,1:100)

# Compute the J x P likelihood matrix.
cat(sprintf("Computing %d x %d likelihood matrix.\n",J,length(Ulist)))
out.time <- system.time(out <- calc_lik_matrix(mash_data,Ulist,log = TRUE,
                                               algorithm.version = "Rcpp"))
cat(sprintf("Likelihood calculations took %0.2f seconds.\n",
            out.time["elapsed"]))

library(mashr)

# For testing, load all packages listed in the "imports" field, and
# load all the functions defined in the source files.
# to overwrite the mashr package defaults
# source("R/mash.R")
# source("R/compute_covs.R")
# source("R/data2cov.R")
# source("R/ed.R")
# source("R/get_functions.R")
# source("R/likelihoods.R")
# source("R/opt.R")
# source("R/plots.R")
# source("R/posterior.R")
# source("R/set_data.R")
# source("R/simulations.R")

# SCRIPT PARAMETERS.
J  <- 1e4  # Number of samples.
K  <- 10   # Number of dimensions/conditions.
nc <- 20    # Number of CPUs ("cores") to use.

J <- ceiling(J/4)*4

# Generate the error s.d.'s.
s <- sqrt(rchisq(J*K,df = J-1)/(J-1))

# Generate a simulated data set.
mash_data   <- simple_sims(J/4,K,s)
mash_data   <- mash_set_data(mash_data$Bhat, mash_data$Shat)
Ulist       <- cov_canonical(mash_data)
Ulist       <- mashr:::expand_cov(Ulist,1:100)
weights     <- matrix(runif(length(Ulist)*J),J,length(Ulist))
weights     <- weights/rowSums(weights)

# Compute posterior quantities.
cat(sprintf("Computing posterior matrices using %d cores.\n",nc))
out.time <-
  system.time(out <- compute_posterior_matrices(mash_data,Ulist,weights,
                                                algorithm.version = "Rcpp",
                                                mc.cores = nc))
cat(sprintf("Posterior computations took %0.2f seconds.\n",
            out.time["elapsed"]))

context("test_ash.R")
test_that("get same result as ash, EE model", {
  library(ashr)
  set.seed(100)
  sim_data <- mashr::simple_sims(nsamp = 100, err_sd = runif(400*5))
  rownames(sim_data$Bhat) = colnames(sim_data$Bhat) = NULL
  rownames(sim_data$Shat) = colnames(sim_data$Shat) = NULL

  # The simulation consists of equal numbers of four different types
  # of effects: null, equal among conditions, present only in first
  # condition, independent across conditions
  ashres = suppressWarnings(ash(sim_data$Bhat[,1],sim_data$Shat[,1],
      mixcompdist="normal",outputlevel=3)) # get ash results for first condition

  data = mash_set_data(sim_data$Bhat, sim_data$Shat, alpha=0)
  U  = list(first_singleton = cov_first_singleton(data))
  out <- capture.output(
    res <- mash(data,U,grid = get_fitted_g(ashres)$sd,prior = "nullbiased",
                usepointmass = FALSE,output_lfdr = TRUE))

  expect_equal(ashr::get_pm(res)[,1],ashr::get_pm(ashres),tolerance = 1e-5)
  expect_equal(ashr::get_psd(res)[,1],ashr::get_psd(ashres),tolerance = 1e-5)
  expect_equal(ashr::get_np(res)[,1],ashr::get_np(ashres),tolerance = 1e-5)
  expect_equal(ashr::get_lfdr(res)[,1],ashr::get_lfdr(ashres),tolerance = 5e-5)

  m2 = mash_1by1(data, alpha=0)
  expect_equal(ashr::get_lfsr(m2)[,1], ashr::get_lfsr(ashres))
  expect_equal(ashr::get_pm(m2)[,1], ashr::get_pm(ashres))
  expect_equal(ashr::get_psd(m2)[,1], ashr::get_psd(ashres))
})

test_that("get same result as ash, EZ model", {
  library(ashr)
  set.seed(100)
  sim_data = mashr::simple_sims(nsamp = 100, err_sd = runif(400*5))
  rownames(sim_data$Bhat) = colnames(sim_data$Bhat) = NULL
  rownames(sim_data$Shat) = colnames(sim_data$Shat) = NULL
  # The simulation consists of equal numbers of four different types
  # of effects: null, equal among conditions, present only in first
  # condition, independent across conditions
  ashres = suppressWarnings(ash(sim_data$Bhat[,1],sim_data$Shat[,1],mixcompdist="normal",outputlevel=3, alpha = 1)) # get ash results for first condition

  data = mash_set_data(Bhat = sim_data$Bhat, Shat = sim_data$Shat, alpha=1)
  U  = list(first_singleton = cov_first_singleton(data))
  out <- capture.output(
    res <- mash(data,U,grid = get_fitted_g(ashres)$sd,prior = "nullbiased",
                usepointmass = FALSE,output_lfdr = TRUE))

  expect_equal(ashr::get_pm(res)[,1],ashr::get_pm(ashres),tolerance = 1e-5)
  expect_equal(ashr::get_psd(res)[,1],ashr::get_psd(ashres),tolerance = 1e-5)
  expect_equal(ashr::get_np(res)[,1],ashr::get_np(ashres),tolerance = 1e-5)
  expect_equal(ashr::get_lfdr(res)[,1],ashr::get_lfdr(ashres),tolerance = 5e-5)
})

test_that("get same result as ash under transformation, EE model", {
  library(ashr)
  set.seed(100)
  sim_data = mashr::simple_sims(nsamp = 100, err_sd = runif(400*5))
  rownames(sim_data$Bhat) = colnames(sim_data$Bhat) = NULL
  rownames(sim_data$Shat) = colnames(sim_data$Shat) = NULL

  # The simulation consists of equal numbers of four different types
  # of effects: null, equal among conditions, present only in first
  # condition, independent across conditions
  ashres = ash(sim_data$Bhat[,1],sim_data$Shat[,1],
               mixcompdist="normal",outputlevel=3, alpha = 0) # get ash results for first condition

  data = mash_set_data(Bhat = sim_data$Bhat, Shat = sim_data$Shat, alpha=0)
  U  = list(first_singleton = cov_first_singleton(data))
  out <- capture.output(
    res <- mash(data,U,grid = get_fitted_g(ashres)$sd,prior = "nullbiased",
                usepointmass = FALSE, outputlevel = 1))
  A = rbind(c(1,0,0,0,0))
  res$result = mash_compute_posterior_matrices(res, data, A=A)
  # print('FIXME: Rcpp not implemented')

  expect_equal(dim(ashr::get_pm(res)), c(400,1))
  expect_equal(as.numeric(ashr::get_pm(res)),ashr::get_pm(ashres),tolerance = 1e-5)
  expect_equal(as.numeric(ashr::get_psd(res)),ashr::get_psd(ashres),tolerance = 1e-5)
  expect_equal(as.numeric(ashr::get_np(res)),ashr::get_np(ashres),tolerance = 1e-5)
  expect_equal(as.numeric(ashr::get_lfdr(res)),ashr::get_lfdr(ashres),tolerance = 5e-5)
})

test_that("get same result as ash under transformation, EZ model", {
  library(ashr)
  set.seed(100)
  sim_data = mashr::simple_sims(nsamp = 100, err_sd = runif(400*5))
  rownames(sim_data$Bhat) = colnames(sim_data$Bhat) = NULL
  rownames(sim_data$Shat) = colnames(sim_data$Shat) = NULL
  # The simulation consists of equal numbers of four different types
  # of effects: null, equal among conditions, present only in first
  # condition, independent across conditions
  ashres = suppressWarnings(ash(sim_data$Bhat[,1],sim_data$Shat[,1],
               mixcompdist="normal",outputlevel=3, alpha = 1)) # get ash results for first condition

  data = mash_set_data(Bhat = sim_data$Bhat, Shat = sim_data$Shat, alpha=1)
  U  = list(first_singleton = cov_first_singleton(data))
  out <- capture.output(
    res <- mash(data,U,grid = get_fitted_g(ashres)$sd,prior = "nullbiased",
                usepointmass = FALSE, outputlevel = 1))
  A = rbind(c(1,0,0,0,0))
  res$result = mash_compute_posterior_matrices(res, data, A=A)
  # print('FIXME: Rcpp not implemented')

  expect_equal(dim(ashr::get_pm(res)), c(400,1))
  expect_equal(as.numeric(ashr::get_pm(res)),ashr::get_pm(ashres),tolerance = 1e-5)
  expect_equal(as.numeric(ashr::get_psd(res)),ashr::get_psd(ashres),tolerance = 1e-5)
  expect_equal(as.numeric(ashr::get_np(res)),ashr::get_np(ashres),tolerance = 1e-5)
  expect_equal(as.numeric(ashr::get_lfdr(res)),ashr::get_lfdr(ashres),tolerance = 5e-5)
})

context("test_set_data.R")
test_that("Initialize MASH data properly", {
  Bhat = rbind(c(1,2),c(2,6))
  Shat = rbind(c(1,1),c(2,2))
  dat1 = mash_set_data(Bhat, Shat, df = 2)
  dat1$Z = dat1$Bhat/dat1$Shat
  dat2 = mash_set_data(dat1$Z)
  expect_equal(dat2$Shat, matrix(1,2,2))
  dat3 = mash_set_data(Bhat, pval = 2 * pt(-abs(Bhat/Shat), df = 2))
  expect_equal(dat1$Shat, dat3$Shat)
})

test_that("Inf, NaN and zeros in Shat in input are detected and handled", {
  # NaN in Bhat
  Bhat = rbind(c(NaN,2),c(2,6))
  Shat = rbind(c(1,1),c(2,2))
  dat1 = expect_error(mash_set_data(Bhat, Shat, df = 2))
  # NaN in Shat
  Bhat = rbind(c(1,2),c(2,6))
  Shat = rbind(c(1,NaN),c(2,2))
  dat1 = expect_error(mash_set_data(Bhat, Shat, df = 2))
  # Inf in Bhat
  Bhat = rbind(c(Inf,2),c(2,6))
  Shat = rbind(c(1,1),c(2,2))
  dat1 = expect_error(mash_set_data(Bhat, Shat, df = 2))
  # Inf in Shat
  Bhat = rbind(c(1,2),c(2,6))
  Shat = rbind(c(1,Inf),c(2,2))
  dat1 = expect_error(mash_set_data(Bhat, Shat, df = 2))
  # Zero value in Shat
  Bhat = rbind(c(1,2),c(2,6))
  Shat = rbind(c(1,0),c(2,2))
  dat1 = expect_error(mash_set_data(Bhat, Shat, df = 2))
  # Zero value in Shat and Bhat
  Bhat = rbind(c(1,0),c(2,6))
  Shat = rbind(c(1,0),c(2,2))
  dat1 = expect_error(mash_set_data(Bhat, Shat, df = 2))
})

test_that("NA values in input data are correctly handled", {
  # NA in Bhat not in Shat
  Bhat = rbind(c(NA,2),c(2,6))
  Shat = rbind(c(1,1),c(2,2))
  dat1 = expect_error(mash_set_data(Bhat, Shat))
  # NA in both Bhat and Shat
  Bhat = rbind(c(1,NA),c(2,6))
  Shat = rbind(c(1,NA),c(2,2))
  dat1 = mash_set_data(Bhat, Shat)
  expect_equal(dat1$Bhat[1,2], 0)
  expect_equal(dat1$Shat[1,2], 1E6)
  dat1 = mash_set_data(Bhat, Shat, alpha=1)
  expect_equal(dat1$Bhat[1,2], 0)
  expect_equal(dat1$Shat[1,2], 1E6)
})

test_that("Contrast matrix generate L properly", {
  L = rbind(c(-1,1,0), c(-1,0,1))
  row.names(L) = c('2-1', '3-1')
  colnames(L) = 1:3
  attr(L, 'reference') = 1
  L.out = contrast_matrix(3, 1, 1:3)
  expect_equal(L, L.out)

  L = rbind(c(1,-1,0), c(0,-1,1))
  row.names(L) = c('1-2', '3-2')
  colnames(L) = 1:3
  attr(L, 'reference') = 2
  L.out = contrast_matrix(3, 2, 1:3)
  expect_equal(L, L.out)

  L = rbind(c(1,0,-1), c(0,1,-1))
  row.names(L) = c('1-3', '2-3')
  colnames(L) = 1:3
  attr(L, 'reference') = 3
  L.out = contrast_matrix(3, 3, 1:3)
  expect_equal(L, L.out)

  L = rbind(c(2/3, -1/3, -1/3), c(-1/3, 2/3, -1/3))
  row.names(L) = c('1-mean', '2-mean')
  colnames(L) = 1:3
  attr(L, 'reference') = 'mean'
  L.out = contrast_matrix(3, 'mean', 1:3)
  expect_equal(L, L.out)
})

test_that("Initialize MASH CONTRAST data properly", {
  Bhat = rbind(c(1,2,3),c(2,6,8))
  Shat = rbind(c(1,1,1),c(2,2,2))
  dat1 = mash_set_data(Bhat, Shat)
  L = diag(3); L[,1] = -1
  L = L[2:3,]
  dat2 = mash_set_data_contrast(dat1, L)
  expect_equal(dat2$Shat, matrix(c(sqrt(2),sqrt(2),sqrt(8),sqrt(8)),2,2, byrow = TRUE))
  expect_equal(dat2$Shat_orig, dat1$Shat)
  expect_equal(dat2$L, L)
  expect_equal(dat2$alpha, 0)
})

context("test_cov.R")
test_that("prior covariance computations look right", {
  Bhat = rbind(c(1,2),c(2,4))
  Shat = rbind(c(1,1),c(1,1))
  data = mash_set_data(Bhat,Shat)

  Ulist = cov_singletons(data)
  expect_equal(Ulist, list(cbind(c(1,0),c(0,0)), cbind(c(0,0),c(0,1))))

  Ulist = cov_equal_effects(data)
  expect_equal(Ulist, cbind(c(1,1),c(1,1)))

  Ulist = cov_identity(data)
  expect_equal(Ulist, cbind(c(1,0),c(0,1)))

  Ulist = cov_canonical(data, list(identity2 = list(fn=cov_identity)))
  expect_equal(Ulist, list(identity2=cbind(c(1,0),c(0,1))))

  Ulist = cov_canonical(data, "id")
  expect_equal(Ulist, list(identity=cbind(c(1,0),c(0,1))))

  Ulist = scale_cov(Ulist, c(1,2))
  expect_equal(Ulist, list(identity.1 = cbind(c(1,0),c(0,1)),
               identity.2 = cbind(c(4,0),c(0,4))))

  # test naming of scaled Ulist
  Ulist = cov_canonical(data,c("sing","null"))
  Ulist = scale_cov(Ulist, c(sqrt(3),sqrt(4)))
  expect_equal(Ulist, list(singletons_1.1 = cbind(c(3,0),c(0,0)),
                           singletons_2.1 = cbind(c(0,0),c(0,3)),
                           null.1 = cbind(c(0,0),c(0,0)),
                           singletons_1.2 = cbind(c(4,0),c(0,0)),
                           singletons_2.2 = cbind(c(0,0),c(0,4)),
                           null.2 = cbind(c(0,0),c(0,0))) )

  # test matching of arguments
  Ulist = cov_canonical(data, c("nul","equal"))
  expect_equal(Ulist, list(null = cbind(c(0,0),c(0,0)), equal_effects = cbind(c(1,1),c(1,1))))

}
)

test_that("normalizations look right", {
  testlist = list(cbind(c(1,2),c(3,4)), cbind(c(5,6),c(7,8)))
  expect_equal(normalize_cov(testlist[[1]]), testlist[[1]]/4)
  expect_equal(normalize_Ulist(testlist), list(testlist[[1]]/4,testlist[[2]]/8))
}
)

context("test_estimate_cor.R")
test_that("Estimate null correlation properly: alpha = 0", {
  Bhat = rbind(c(1,1.5,0.5),c(0.5,1,0.2), c(-0.8,-0.5,-1), c(0.6,1.7,0.3))
  Shat = rbind(c(1,1,1),c(1,1,1),c(1,1,1),c(1,1,1))
  data = mash_set_data(Bhat,Shat)
  Ulist = cov_canonical(data)

  V.adhoc = estimate_null_correlation_simple(data)
  data.adhoc = mash_update_data(data, V = V.adhoc)
  out <- capture.output(mash.adhoc <- mash(data.adhoc, Ulist, outputlevel = 3))

  V.est <- mash_estimate_corr_em(data, Ulist, max_iter = 0, details = TRUE)

  expect_equal(V.adhoc, V.est$V)
  expect_equal(mash.adhoc, V.est$mash.model)

  # saved result comes from version 0.2.21.0641
  skip_if_not(file.exists("estimate_null_cor.rds"))
  original.null.cor = readRDS('estimate_null_cor.rds')
  set.seed(1)
  simdata = simple_sims(500,5,0.5)

  data = mash_set_data(simdata$Bhat, simdata$Shat, alpha = 0)
  U.c = cov_canonical(data)

  V.est <- mash_estimate_corr_em(data, U.c, max_iter = 3, details = TRUE,
                                 output_lfdr = TRUE)
  expect_equal(V.est$V, original.null.cor$V, tolerance = 5e-4)
  expect_equal(V.est$mash.model, original.null.cor$mash.model, tolerance = 5e-4)
})

test_that("Estimate null correlation properly: alpha = 1", {
  Bhat = rbind(c(1,1.5,0.5),c(0.5,1,0.2), c(-0.8,-0.5,-1), c(0.6,1.7,0.3))
  Shat = 1.5
  data = mash_set_data(Bhat,Shat, alpha=1)
  Ulist = cov_canonical(data)

  V.adhoc = estimate_null_correlation_simple(data)
  data.adhoc = mash_update_data(data, V = V.adhoc)
  out <- capture.output(mash.adhoc <- mash(data.adhoc, Ulist, outputlevel = 3))

  V.est <- mash_estimate_corr_em(data, Ulist, max_iter = 0, details = TRUE)

  expect_equal(V.adhoc, V.est$V)
  expect_equal(mash.adhoc, V.est$mash.model)

  # saved result comes from version 0.2.18.0532
  skip_if_not(file.exists("estimate_null_cor_alpha.rds"))
  original.null.cor = readRDS('estimate_null_cor_alpha.rds')
  set.seed(1)
  simdata = simple_sims(500,5,0.5)

  data = mash_set_data(simdata$Bhat, simdata$Shat, alpha=1)
  U.c = cov_canonical(data)

  V.est <- mash_estimate_corr_em(data, U.c, max_iter = 3, details = TRUE,
                                     output_lfdr = TRUE)
  expect_equal(V.est$V, original.null.cor$V, tolerance = 5e-4)
  expect_equal(V.est$mash.model, original.null.cor$mash.model, tolerance = 5e-4)
})

context("test_likelihood.R")

test_that("likelihood calculations look right",{
  Bhat = rbind(c(1,2,3),c(2,4,6))
  Shat = rbind(c(1,1,1),c(2,2,2))
  data = mash_set_data(Bhat, Shat)
  Ulist = cov_singletons(data)
  mm = calc_lik_matrix(data, Ulist)
  data2 = mash_set_data(Bhat[1,,drop=FALSE],Shat[1,,drop=FALSE])
  vv = calc_lik_matrix(data2, Ulist)
  expect_equal(mm[1,,drop=FALSE],vv)
  mm2 = calc_relative_lik_matrix(data, Ulist)$loglik_matrix
  expect_equal(cor(mm[1,],exp(mm2[1,])),1)
})

test_that("likelihood calculations on test set match original",{
  Bhat = rbind(c(1,2,3),c(2,4,6))
  Shat = rbind(c(1,1,1),c(2,2,2))
  data = mash_set_data(Bhat,Shat)
  Ulist = cov_canonical(data)
  out <- capture.output(m <- mash(data,Ulist,grid = c(0.5,1,2)))
  expect_equal(mash_compute_loglik(m,data),m$loglik)
  expect_equal(mash_compute_loglik(m$fitted_g,data),m$loglik)
})

test_that('likelihood calculations on mash contrast set',{
  Bhat = rbind(c(1,2,3),c(2,4,6))
  Shat = rbind(c(1,1,1),c(2,2,2))
  data = mash_set_data(Bhat,Shat)
  # L = diag(3); L[,1] = -1; L = L[2:3,]
  L = contrast_matrix(3,1)
  data1 = mash_set_data_contrast(data, L)
  Ulist = cov_canonical(data1)

  out <- capture.output(m1 <- mash(data1,Ulist,grid = c(0.5,1,2),
                        algorithm.version = 'R'))
  expect_equal(mash_compute_loglik(m1,data1, algorithm.version='R'),m1$loglik)

  out <- capture.output(m2 <- mash(data1,Ulist,grid = c(0.5,1,2),
                                   algorithm.version = 'Rcpp'))
  expect_equal(mash_compute_loglik(m2,data1, algorithm.version='Rcpp'),m2$loglik)
  expect_equal(m1$loglik, m2$loglik)
})

context("test_posterior_common_cov.R")
test_that("posterior calculations with common cov match regular version",{
  Bhat = rbind(c(1,2,3),c(2,4,6))
  Shat = rbind(c(1,1,1),c(1,1,1))
  data = mash_set_data(Bhat,Shat)
  Ulist = cov_canonical(data)
  posterior_weights = matrix(1/length(Ulist),nrow = 2, ncol=length(Ulist))
  out1 = compute_posterior_matrices_general_R(data,A=diag(3),Ulist,posterior_weights)
  out2 = compute_posterior_matrices_common_cov_R(data,A=diag(3),Ulist,posterior_weights)
  expect_equal(out1,out2)
  out1 = calc_post_rcpp(t(data$Bhat),t(data$Shat), matrix(0,0,0), matrix(0,0,0), data$V, matrix(0,0,0), diag(ncol(data$Bhat)), simplify2array(Ulist),t(posterior_weights), TRUE, FALSE)
  out2 = calc_post_rcpp(t(data$Bhat),t(data$Shat), matrix(0,0,0), matrix(0,0,0), data$V, matrix(0,0,0), diag(ncol(data$Bhat)), simplify2array(Ulist),t(posterior_weights), FALSE, FALSE)
  expect_equal(out1,out2)
}
)

context("test_getfunctions.R")

test_that("ashr get functions work",{
  Bhat = rbind(c(1,2,3),c(2,4,6))
  Shat = rbind(c(1,1,1),c(2,2,2))
  data = mash_set_data(Bhat,Shat)
  Ulist = cov_canonical(data)
  out <- capture.output(m <- mash(data,Ulist,grid = c(0.5,1,2),
                                  output_lfdr = TRUE))
  expect_length(get_lfsr(m),6)
  expect_length(get_lfdr(m),6)
  expect_length(get_pm(m),6)
  expect_length(get_psd(m),6)
  expect_length(get_np(m),6)
  expect_length(get_log10bf(m),2)
  out <- capture.output(m <- mash(data,Ulist,grid=c(0.5,1,2),
                                  usepointmass = FALSE))
  expect_null(get_log10bf(m))
  Ulist = cov_udi(data,c("I","D","U"))
  out <- capture.output(m <- mash(data,Ulist,grid = 1,normalizeU = FALSE))
  Ulist2 = c(list(null= mashr:::cov_all_zeros(data)),
             cov_udi(data,c("I","D","U")))
  temp = calc_lik_matrix(data,Ulist2,log=TRUE)
  expect_equal(as.numeric(log10(exp(temp[,2]-temp[,1]))),
               as.numeric(get_log10bf(m)),tolerance = 1e-3)
})

test_that("get_estimated_pi works",{
  Bhat = rbind(c(1,2,3),c(2,4,6))
  Shat = rbind(c(1,1,1),c(2,2,2))
  data = mash_set_data(Bhat,Shat)
  Ulist = cov_canonical(data)
  out <- capture.output(m1 <- mash(data,Ulist,grid = c(0.5,1,2),
                                   usepointmass = FALSE))
  out <- capture.output(m2 <- mash(data,Ulist,grid = c(0.5,1,2),
                                   usepointmass = TRUE))

  expect_length(get_estimated_pi(m1,"all"),3*length(Ulist))
  expect_length(get_estimated_pi(m1,"cov"),length(Ulist))
  expect_length(get_estimated_pi(m1,"grid"),3)

  expect_length(get_estimated_pi(m2,"all"),3*length(Ulist)+1)
  expect_length(get_estimated_pi(m2,"cov"),length(Ulist)+1)
  expect_length(get_estimated_pi(m2,"grid"),4)
})

context("test_likelihood_common_cov.R")
test_that("likelihood calculations with common cov look right",{
  Bhat = rbind(c(1,2,3),c(2,4,6))
  Shat = rbind(c(1,1,1),c(1,1,1))
  data = mash_set_data(Bhat, Shat)
  Ulist = cov_singletons(data)
  mm = calc_lik_matrix(data, Ulist)
  mm2 = calc_lik_matrix_common_cov(data, Ulist)
  expect_equal(is_common_cov_Shat(data),TRUE)
  expect_equal(mm,mm2)
  Bhat = rbind(c(1,2,3),c(2,4,6))
  Shat = rbind(c(1,1,1),c(2,2,2))
  data = mash_set_data(Bhat,Shat)
  expect_equal(is_common_cov_Shat(data),FALSE)
}
)

context("test_cpp_computation.R")
test_that("compare likelihood computation R vs C++ in provided data of 100 X 5", {

  load("calc_lik_matrix_data.RData")
  data$commonV = TRUE
  ## Get the number of samples (J) and the number of mixture components (P).
  J <- nrow(data$Bhat)
  P <- length(Ulist)

  ## Compute the likelihood matrix using the R implementation.
  out.time <- system.time(out1 <- calc_lik_matrix(data,Ulist,log = TRUE,
                                                  algorithm.version = "R"))

  ## Compute the likelihood matrix using the Rcpp implementation.
  out.time <- system.time(out2 <- calc_lik_matrix(data,Ulist,log = TRUE,
                                                  algorithm.version = "Rcpp",
                                                  mc.cores = 4))

  expect_equal(out1, out2, tolerance=1e-5)
}
)

test_that("compare likelihood computation with contrast matrix R vs C++ in provided data of 100 X 5", {


  load("calc_lik_matrix_data.RData")
  data = mash_set_data(data$Bhat, data$Shat, V = data$V)
  data = mash_update_data(data, ref = 5)
  Ulist = lapply(Ulist, function(U) data$L %*% (U %*% t(data$L)))
  ## Get the number of samples (J) and the number of mixture components (P).
  J <- nrow(data$Bhat)
  P <- length(Ulist)

  ## Compute the likelihood matrix using the R implementation.
  out.time <- system.time(out1 <- calc_lik_matrix(data,Ulist,log = TRUE,
                                                  algorithm.version = "R"))

  ## Compute the likelihood matrix using the Rcpp implementation.
  out.time <- system.time(out2 <- calc_lik_matrix(data,Ulist,log = TRUE,
                                                  algorithm.version = "Rcpp",
                                                  mc.cores = 4))

  expect_equal(out1, out2, tolerance=1e-5)
}
)

test_that("compare likelihood computation R vs C++ in simulated data R = 1", {
  set.seed(999)
  N = 10
  Shat = matrix(abs(rnorm(N)),ncol=1)
  Bhat = matrix(rnorm(N),ncol=1)
  data = mash_set_data(Bhat,Shat)
  Ulist = list(id=matrix(1,nrow=1))
  out1 = calc_lik_matrix(data,Ulist, mc.cores = 4)
  out2 = calc_lik_matrix(data,Ulist,algorithm.version = "R")
  expect_equal(out1, out2, tolerance=1e-5)
}
)

test_that("compare likelihood computation R vs C++ in simulated data common cov", {
  Bhat = rbind(c(1,2,3),c(2,4,6))
  Shat = rbind(c(1,1,1),c(1,1,1))
  data = mash_set_data(Bhat, Shat)
  Ulist = cov_singletons(data)
  out1 = calc_lik_matrix(data, Ulist, mc.cores = 4)
  out2 = calc_lik_matrix(data, Ulist, algorithm.version = "R")
  expect_equal(out1, out2, tolerance=1e-5)
}
)

test_that("compare likelihood computation with contrast matrix R vs C++ in simulated data common cov", {
  Bhat = rbind(c(1,2,3),c(2,4,6))
  Shat = rbind(c(1,1,1),c(1,1,1))
  data = mash_set_data(Bhat, Shat)
  data = mash_update_data(data, ref=1)
  Ulist = cov_singletons(data)
  out1 = calc_lik_matrix(data, Ulist, mc.cores = 4)
  out2 = calc_lik_matrix(data, Ulist, algorithm.version = "R")
  expect_equal(out1, out2, tolerance=1e-5)
}
)

test_that("compare posterior computation R vs C++ in provided data of 100 X 5", {
  # Load the data.
  load("compute_posterior_matrices_data.RData")
  data$commonV = TRUE
  # Compute the posterior quantities using the R implementation.
  out.time <- system.time(out1 <-
                compute_posterior_matrices(data,Ulist,posterior_weights,
                                           algorithm.version = "R"))

  # Compute the posterior quantities using the Rcpp implementation.
  out.time <- system.time(out2 <-
                compute_posterior_matrices(data,Ulist,posterior_weights,
                                           algorithm.version = "Rcpp",
                                           mc.cores = 4))
  expect_equal(out1$PosteriorMean,out2$PosteriorMean,tolerance = 1e-5)
  expect_equal(out1$NegativeProb,out2$NegativeProb,tolerance = 1e-5)
  expect_equal(out1$lfdr,out2$lfdr,tolerance = 1e-5)
  expect_equal(out1$lfsr,out2$lfsr,tolerance = 1e-5)
}
)

test_that("compare linear transformed posterior computation R vs C++ in provided data of 100 X 5", {
  # Load the data.
  load("compute_posterior_matrices_data.RData")
  data$commonV = TRUE
  A = rbind(c(1,1,-1,-1,0),
            c(-1,1,-1,1,0))
  # Compute the posterior quantities using the R implementation.
  out.time <- system.time(out1 <-
                            compute_posterior_matrices(data,Ulist,posterior_weights,
                                                       algorithm.version = "R", A=A))

  # Compute the posterior quantities using the Rcpp implementation.
  out.time <- system.time(out2 <-
    compute_posterior_matrices(data,Ulist,posterior_weights,
                               algorithm.version = "Rcpp", A=A, mc.cores = 4))
  expect_equal(out1, out2, tolerance=1e-5)
}
)

test_that("compare posterior computation R vs C++ in simulated data R = 1 non common cov", {
  set.seed(999)
  N = 10
  Shat = matrix(abs(rnorm(N)),ncol=1)
  Bhat = matrix(rnorm(N),ncol=1)
  data = mash_set_data(Bhat,Shat)
  Ulist = list(id=matrix(1,nrow=1))
  posterior_weights = matrix(rep(1,N),N,1)
  out1 <- compute_posterior_matrices(data,Ulist,posterior_weights,
                                     algorithm.version = "R")
  out2 <- compute_posterior_matrices(data,Ulist,posterior_weights,
                                     algorithm.version = "Rcpp",
                                     mc.cores = 4)
  expect_equal(out1, out2, tolerance=1e-5)
}
)

test_that("compare posterior computation R vs C++ in simulated data R = 1 common cov", {
  set.seed(999)
  N = 10
  Shat = matrix(rep(1,N),ncol=1)
  Bhat = matrix(rnorm(N),ncol=1)
  data = mash_set_data(Bhat,Shat)
  Ulist = list(id=matrix(1,nrow=1))
  posterior_weights = matrix(rep(1,N),N,1)
  out1 <- compute_posterior_matrices(data,Ulist,posterior_weights,
                                     algorithm.version = "R")
  out2 <- compute_posterior_matrices(data,Ulist,posterior_weights,
                                     algorithm.version = "Rcpp",
                                     mc.cores = 4)
  expect_equal(out1, out2, tolerance=1e-5)
}
)

test_that(paste("compare posterior computation R vs C++ in simulated",
                "data common cov"),{
  Bhat    <- rbind(c(1,2,3),c(2,4,6))
  Shat    <- rbind(c(1,1,1),c(1,1,1))
  data    <- mash_set_data(Bhat, Shat)
  Ulist   <- cov_canonical(data)
  Ulist   <- expand_cov(Ulist, 1:50)
  weights <- matrix(runif(length(Ulist) * 2), 2, length(Ulist))
  weights <- weights / rowSums(weights)

  out1 <- compute_posterior_matrices(data, Ulist, weights,
                                     algorithm.version = "Rcpp",
                                     mc.cores = 4)
  out2 <- compute_posterior_matrices(data, Ulist, weights,
                                     algorithm.version = "R")
  expect_equal(out1, out2, tolerance = 1e-5)
})



test_that(paste("compare posterior computation R vs C++ in simulated",
                "data non common cov"),{
  Bhat    <- rbind(c(1,2,3),c(2,4,6))
  Shat    <- rbind(c(1,2,1),c(2,1,1))
  data    <- mash_set_data(Bhat, Shat)
  Ulist   <- cov_canonical(data)
  Ulist   <- expand_cov(Ulist, 1:50)
  weights <- matrix(runif(length(Ulist) * 2), 2, length(Ulist))
  weights <- weights / rowSums(weights)

  out1 <- compute_posterior_matrices(data, Ulist, weights,
                                     algorithm.version = "Rcpp",
                                     mc.cores = 4)
  out2 <- compute_posterior_matrices(data, Ulist, weights,
                                     algorithm.version = "R")
  expect_equal(out1, out2, tolerance = 1e-5)
})

test_that(paste("compare transformed posterior computation R vs C++ in simulated",
                "data common cov"),{
  Bhat    <- rbind(c(1,2,3),c(2,4,6))
  Shat    <- rbind(c(1,1,1),c(1,1,1))
  data    <- mash_set_data(Bhat, Shat)
  Ulist   <- cov_canonical(data)
  Ulist   <- expand_cov(Ulist, 1:50)
  weights <- matrix(runif(length(Ulist) * 2), 2, length(Ulist))
  weights <- weights / rowSums(weights)

  A = rbind(c(1,1,1))

  out1 <- compute_posterior_matrices(data, Ulist, weights,
                                     algorithm.version = "Rcpp", A=A, mc.cores = 4)
  out2 <- compute_posterior_matrices(data, Ulist, weights,
                                     algorithm.version = "R", A=A)
  expect_equal(out1, out2, tolerance = 1e-5)
})

test_that(paste("compare transformed posterior computation R vs C++ in simulated",
                "data non common cov"),{
  Bhat    <- rbind(c(1,2,3),c(2,4,6))
  Shat    <- rbind(c(1,2,1),c(2,1,1))
  data    <- mash_set_data(Bhat, Shat)
  Ulist   <- cov_canonical(data)
  Ulist   <- expand_cov(Ulist, 1:50)
  weights <- matrix(runif(length(Ulist) * 2), 2, length(Ulist))
  weights <- weights / rowSums(weights)

  A = rbind(c(1,1,1))
  out1 <- compute_posterior_matrices(data, Ulist, weights,
                                     algorithm.version = "Rcpp", A=A, mc.cores = 4)
  out2 <- compute_posterior_matrices(data, Ulist, weights,
                                     algorithm.version = "R", A=A)
  expect_equal(out1, out2, tolerance = 1e-5)
})

test_that(paste("compare commonbaseline and transformed computation R vs C++ in simulated",
                "data common cov"),{
  Bhat    <- rbind(c(1,2,3),c(2,4,6))
  Shat    <- rbind(c(1,1,1),c(1,1,1))
  data    <- mash_set_data(Bhat, Shat)
  data.L  <- mash_update_data(data, ref=1)
  Ulist   <- cov_canonical(data.L)

  A = rbind(c(1,1))
  out1 <- mash(data.L, Ulist, algorithm.version = "Rcpp", A = A, verbose = F)
  out2 <- mash(data.L, Ulist, algorithm.version = "R", A = A, verbose = F)
  expect_equal(out1, out2, tolerance = 1e-5)
})

test_that(paste("compare commonbaseline and transformed computation R vs C++ in simulated",
                "data non common cov"),{
  Bhat    <- rbind(c(1,2,3),c(2,4,6))
  Shat    <- rbind(c(1,2,1),c(2,1,1))
  data    <- mash_set_data(Bhat, Shat)
  data.L  <- mash_update_data(data, ref=1)
  Ulist   <- cov_canonical(data.L)

  A = rbind(c(1,1))
  out1 <- mash(data.L, Ulist, algorithm.version = "Rcpp", A = A, verbose = F)
  out2 <- mash(data.L, Ulist, algorithm.version = "R", A = A, verbose = F)
  expect_equal(out1, out2, tolerance = 1e-5)
})

test_that(paste("compare nobaseline computation R vs C++ in simulated",
                "data common cov"),{
  Bhat    <- rbind(c(1,2,3),c(2,4,6))
  Shat    <- rbind(c(1,1,1),c(1,1,1))
  data    <- mash_set_data(Bhat, Shat)
  data.L  <- mash_update_data(data, ref='mean')
  Ulist   <- cov_canonical(data.L)

  out1 <- mash(data.L, Ulist, algorithm.version = "Rcpp", verbose = F)
  out2 <- mash(data.L, Ulist, algorithm.version = "R", verbose = F)
  expect_equal(out1, out2, tolerance = 1e-5)
})

test_that(paste("compare nobaseline computation R vs C++ in simulated",
                "data non common cov"),{
  Bhat    <- rbind(c(1,2,3),c(2,4,6))
  Shat    <- rbind(c(1,2,1),c(2,1,1))
  data    <- mash_set_data(Bhat, Shat)
  data.L  <- mash_update_data(data, ref='mean')
  Ulist   <- cov_canonical(data.L)

  out1 <- mash(data.L, Ulist, algorithm.version = "Rcpp", verbose = F)
  out2 <- mash(data.L, Ulist, algorithm.version = "R", verbose = F)
  expect_equal(out1, out2, tolerance = 1e-5)
})

test_that("Interface agree when R = 1 non common cov", {
  N = 20
  r = 1
  Shat = matrix(abs(rnorm(N)),ncol=r)
  Bhat = matrix(rnorm(N),ncol=r)
  data = mash_set_data(Bhat,Shat)

  prior = list(Ulist = list(id=diag(r)),
               grid = 1, pi_s = c(0.05,0.95), usepointmass = TRUE)
  out1 <- mash(data, g = prior, fixg = TRUE, algorithm.version = "R", verbose = F)
  out2 <- mash(data, g = prior, fixg = TRUE, algorithm.version = "Rcpp", verbose = F)
  expect_equal(get_pm(out1), get_pm(out2), tolerance=1e-5)
})

test_that("Interface agree when R > 1 non common cov, EZ version", {
  N = 20
  r = 2
  Shat = matrix(abs(rnorm(N)),ncol=r)
  Bhat = matrix(rnorm(N),ncol=r)
  data = mash_set_data(Bhat,Shat,alpha=1)

  prior = list(Ulist = list(id=diag(r)),
               grid = 1, pi_s = c(0.05,0.95), usepointmass = TRUE)
  out1 <- mash(data, g = prior, fixg = TRUE, algorithm.version = "R", verbose = F)
  out2 <- mash(data, g = prior, fixg = TRUE, algorithm.version = "Rcpp", verbose = F)
  expect_equal(get_pm(out1), get_pm(out2), tolerance=1e-5)
})

context("test_posterior.R")

test_that("calculations on test set with fixg match original",{
  Bhat = rbind(c(1,2,3),c(2,4,6))
  Shat = rbind(c(1,1,1),c(2,2,2))
  data = mash_set_data(Bhat,Shat)
  Ulist = cov_canonical(data)
  m <- mash(data,Ulist,grid = c(0.5,1,2), verbose = F)
  m2 <- mash(data,g = get_fitted_g(m),fixg = TRUE,verbose = F)
  expect_equal(m2$result,m$result)
})

test_that("diag of posterior covariance matches posterior sd",{
  Bhat = rbind(c(1,2,3),c(2,4,6))
  Shat = rbind(c(1,0.5,1),c(1,1,1))
  data = mash_set_data(Bhat,Shat)
  Ulist = cov_canonical(data)
  res <- mash(data,Ulist,outputlevel=3, algorithm.version = 'Rcpp', verbose = F)$result
  expect_equal(res$PosteriorSD,
               do.call(rbind,lapply(1:dim(res$PosteriorCov)[3],
                       function(i) sqrt(diag(res$PosteriorCov[,,i])))))
  res <- mash(data,Ulist,outputlevel = 3, algorithm.version = 'R', verbose = F)$result
  expect_equal(res$PosteriorSD,
               do.call(rbind,lapply(1:dim(res$PosteriorCov)[3],
                function(i) sqrt(diag(res$PosteriorCov[,,i])))))
})

test_that("diag of posterior covariance matches posterior sd: alpha=1",{
  Bhat = rbind(c(1,2,3),c(2,4,6))
  Shat = rbind(c(1,0.5,1),c(1,1,1))
  data = mash_set_data(Bhat,Shat, alpha=1)
  Ulist = cov_canonical(data)
  res <- mash(data,Ulist,outputlevel=3, algorithm.version = 'Rcpp', verbose = F)$result
  expect_equal(res$PosteriorSD,
               do.call(rbind,lapply(1:dim(res$PosteriorCov)[3],
                                    function(i) sqrt(diag(res$PosteriorCov[,,i])))))
  res <- mash(data,Ulist,outputlevel = 3, algorithm.version = 'R', verbose = F)$result
  expect_equal(res$PosteriorSD,
               do.call(rbind,lapply(1:dim(res$PosteriorCov)[3],
                                    function(i) sqrt(diag(res$PosteriorCov[,,i])))))
})

context("test_simple_sims.R")

test_that("simple simulations look right", {
  set.seed(100)
  test = simple_sims()
  
  # The simulation consists of equal numbers of four different types
  # of effects: null, equal among conditions, present only in first
  # condition, independent across conditions.
  data = mash_set_data(test$Bhat, test$Shat)
  U = cov_canonical(data, c("id","sing","equal_effects"))
  out <- capture.output(
    res <- mash(data, U,grid= c(0.5,1,2), prior="nullbiased"))

  expect_lt(mean(abs(test$B-ashr::get_pm(res))),mean(abs(test$B-test$Bhat)))
}
)

test_that("simple simulations look right; larger error", {
  set.seed(100)
  test = simple_sims(err_sd = 0.5)
  
  # The simulation consists of equal numbers of four different types
  # of effects: null, equal among conditions, present only in first
  # condition, independent across conditions.
  data = mash_set_data(test$Bhat, test$Shat, alpha=0) #set alpha=0 for comparison with ash
  U = cov_canonical(data, c("id","sing","equal_effects"))
  out <- capture.output(
    res <- mash(data, U,grid= c(0.5,1,2), prior="nullbiased"))

  ashres = ashr::ash(test$Bhat[,1],test$Shat[,1])

  expect_lt( #check mean error is better than no shrinkage
    mean(abs(test$B-ashr::get_pm(res))),
    mean(abs(test$B-test$Bhat)))
  expect_lt( #check mean error is better than ash for condition 1
    mean(abs(test$B[,1]-ashr::get_pm(res)[,1])),
    mean(abs(test$B[,1]-ashr::get_pm(ashres))))


  # lfsr= pmin(post$post_zero[,1] + post$post_neg[,1], post$post_zero[,1] + post$post_pos[,1])
  #
  # plot(lfsr, ashr::get_lfsr(ashres))
  # plot(lfsr, test$B[,1])
  # plot(ashr::get_lfsr(ashres), test$B[,1])
  # plot(cumsum((test$B[,1] !=0)[order(lfsr)]))
  # lines(cumsum((test$B[,1] !=0)[order(ashr::get_lfsr(ashres))]),col=2)

  }
)

context("test_Varray.R")
test_that("Input null correlation as 3 dim array in R version, alpha=0", {
  Bhat = rbind(c(1,2,3),c(2,4,6))
  Shat = rbind(c(1,1,1),c(1,0.5,1))

  V = matrix(c(1, 0.2,0.2,0.2,1,0.2,0.2,0.2,1), 3,3)
  V3D = array(V, dim = c(3,3,2))

  data = mash_set_data(Bhat,Shat, V = V, alpha=0)
  data.3D = mash_set_data(Bhat, Shat, V=V3D, alpha=0)

  U.c = cov_canonical(data)

  m = mash(data, U.c, algorithm.version = 'R', verbose = F)

  m3D = mash(data.3D, U.c, algorithm.version = 'R', verbose = F)

  expect_equal(m, m3D)
}
)

test_that("Input null correlation as 3 dim array in R version, alpha=1", {
  Bhat = rbind(c(1,2,3),c(2,4,6))
  Shat = rbind(c(1,1,1),c(1,0.5,1))

  V = matrix(c(1, 0.2,0.2,0.2,1,0.2,0.2,0.2,1), 3,3)
  V3D = array(V, dim = c(3,3,2))

  data = mash_set_data(Bhat,Shat, V = V, alpha=1)
  data.3D = mash_set_data(Bhat, Shat, V=V3D, alpha=1)

  U.c = cov_canonical(data)

  m = mash(data, U.c, algorithm.version = 'R', verbose = F)

  m3D = mash(data.3D, U.c, algorithm.version = 'R', verbose = F)

  expect_equal(m, m3D)
}
)

context("test_cov_udi.R")
test_that("udi covariance computations look right", {
  set.seed(1)
  Bhat = matrix(rnorm(100),ncol=5)
  L = matrix(rnorm(25),nrow=5,ncol=5)
  V = L %*% t(L)
  data = mash_set_data(Bhat,Shat=1,V=V)
  expect_error(cov_udi(data, c("U","U","D","D","A")))
  expect_error(cov_udi(data, c("U","U","I","I","I")))
  expect_equal(names(cov_udi(data, c("U","U","I","I","D"))), "cov_udi_UUIID")
}
)

test_that("Samples from the posterior look right", {
  set.seed(100)
  test = simple_sims()
  data = mash_set_data(test$Bhat, test$Shat)
  U = cov_canonical(data)
  # res = mash(data,U, algorithm.version = 'R', posterior_samples = 100,
  #             usepointmass = FALSE)
  res = mash(data,U, algorithm.version = "R", posterior_samples = 100,
             verbose = FALSE)$result
  expect_equal(dim(res$PosteriorSamples), c(400,5,100))
  expect_equal(t(apply(res$PosteriorSamples, 1, rowMeans)),
               res$PosteriorMean,tolerance = max(res$PosteriorSD))
})

test_that("Samples from the posterior with linear transformation look right", {
  set.seed(100)
  test = simple_sims()
  data = mash_set_data(test$Bhat, test$Shat)
  U = cov_canonical(data)
  res = mash(data,U, algorithm.version = "R", posterior_samples = 100,
             verbose = FALSE, A = matrix(c(1,1,0,0,0), 1, 5))$result
  expect_equal(dim(res$PosteriorSamples), c(400,1,100))
  expect_equal(as.matrix(apply(res$PosteriorSamples, 1, rowMeans)),
               res$PosteriorMean,tolerance = max(res$PosteriorSD))
})

---
title: 'TEEM Rcpp: Accuracy & Speed Comparison'
author: "Yunqi Yang"
date: "4/1/2020"
output:
  pdf_document: default
  html_document: default
---

```{r}
source("/Users/nicholeyang/Desktop/ed/code/EM.R")
load("/Users/nicholeyang/Desktop/ed/data/zstrong.RData")
library(mvtnorm)
```

# Result comparison (A simulate data example)
```{r}

# function for simulate data
sim.data <- function(n, w, U) {
   # w: the true weight
   # mu: a k*m matrix 
   # dimension of an obs. 
   m = nrow(U[[1]])
   # k: number of classes
   k = length(w)
   
   # generate true class variable  
   Z = sample(1:k, n, prob = w, replace = T)  
    
   # store simulated data
   X = matrix(NA, ncol = m, nrow = n)
   
   for (i in 1:n){
     # true class for obs. i 
     j = Z[i]
     X[i, ] = rmvnorm(1,mean = rep(0,m), sigma = U[[j]])
   }
   res = list(X = X, Z = Z)
   return(res)
}

```

```{r  }

# simulate data 
set.seed(215)
n <- 1e4
w <- c(0.6,0.3,0.1)
I <- diag(c(1,1,1))
U <- list(U1 = matrix(1,3,3)+I,
          U2 = crossprod(rbind(c(1,1,0),
                               c(0,1,1)))+I,
          U3 = rbind(2*diag(3))+I)
dt <- sim.data(n, w, U)
X  <- dt$X
```

```{r  }

# initialization
w.init <- c(0.3, 0.4, 0.3)
U.init <-
  list(U1 = matrix(c(1, 0.1, 0.3, 0.1, 1, 0, 0.3, 0 ,1), ncol = 3, nrow =3), 
      U2 = matrix(c(1, 0.1, 0.9, 0.1, 1, 0, 0.9, 0 ,1), ncol = 3, nrow =3),
      U3 = diag(3))



# R version
res.R <- EM.fit(X, w.init, U.init, maxiter = 5000, tol = 1e-7, verbose = FALSE)
## Rcpp version
res.cpp = mashr:::fit_teem_rcpp(X,w.init,simplify2array(U.init), 5000, 1e-7, FALSE)


```


```{r  }

# R version result
res.R$w
res.R$U
tail(res.R$progress$obj)
length(res.R$progress$obj)

# Rcpp result
res.cpp$w
res.cpp$U
tail(res.cpp$objective)
length(res.cpp$objective)
```


# Speed comparison (A real data example)
```{r  }

# The previous Gtex 5 tissue data 
set.seed(215)
test_index = sample(1:nrow(zstrong), 3000, replace = FALSE)
test = zstrong[test_index, ]
train = zstrong[-test_index,]
dim(test)
dim(train)

# Choose components = 5 to fit; Use random initialization
s = 5
w.true = rep(1/s, s)
indx = sample(1:s, nrow(train), replace = TRUE, prob = w.true)
U.init = c()
w.init = rep(NA, s)

# Calculate the empirical covariance matrix. The initialization for U = empirical Sigma + I
for (i in 1:s){
  w.init[i] = sum(indx ==i)/nrow(train)
  dt = train[indx ==i, ]
  Sigma = matrix(t(dt) %*% dt/nrow(dt), nrow = 5, ncol = 5)
  U.init[[i]] = Sigma + diag(5)
}

```


```{r  }

# ED in mashr
train.mash = mashr:::mash_set_data(train, Shat = 1)
U.pca = mashr:::cov_pca(train.mash, 4)

start= proc.time()
res.mashr = mashr:::cov_ed(train.mash, U.pca)
end = proc.time()
runtime.mashr = end - start


# newEM R version
start= proc.time()
res.R = EM.fit(train, w.init, U.init, maxiter = 5000, tol = 1e-7, verbose = FALSE)
end = proc.time()
runtime.R = end - start

# newEM CPP 
start= proc.time()
res.cpp = mashr:::fit_teem_rcpp(train , w.init,simplify2array(U.init), 5000, 1e-7, FALSE)
end = proc.time()
runtime.cpp = end - start

```


```{r  }

runtime.mashr
runtime.R
runtime.cpp
```
